using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.CustomerGroup.Cqrs;

public class UpdateCustomerGroupRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateCustomerGroupResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateCustomerGroupCommand(UpdateCustomerGroupRequest Data) : IRequest<UpdateCustomerGroupResponse>;

public class UpdateCustomerGroupHandler : IRequestHandler<UpdateCustomerGroupCommand, UpdateCustomerGroupResponse>
{
    private readonly AppDbContext _context;

    public UpdateCustomerGroupHandler(AppDbContext context) => _context = context;

    public async Task<UpdateCustomerGroupResponse> Handle(UpdateCustomerGroupCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.CustomerGroup
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Customer Group", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.CustomerGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateCustomerGroupResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;
        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateCustomerGroupResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}